#!/bin/bash

cd `dirname $0`
MYDIR=`pwd`
MYSCRIPT=`basename $0`
cd ../../..
S2P_PATH_BASE=`pwd`
cd $MYDIR

CI_PATH_BASE="$S2P_PATH_BASE/apps/castiron"

HTTP_PORT=`$CI_PATH_BASE/libexec/config_view.py system simple | grep ^http.port | cut -d= -f2`
CI_SERVER_NAME=`$CI_PATH_BASE/libexec/config_view.py brand simple | grep ^name | cut -d= -f2`

S2P_OS_USERNAME=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^os.username | cut -d= -f2`
S2P_OS_GROUPNAME=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^os.groupname | cut -d= -f2`
S2P_PATH_RUN=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^path.run | cut -d= -f2`
S2P_PATH_LOG=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^path.log | cut -d= -f2`

#############################################################################################
# Nanoweb

FILES=`ls -1 $S2P_PATH_BASE/apps/castiron/nanoweb/conf.template/*.conf`
for F in $FILES; do
	FILE=`basename $F`
	sed "s|%CI_PATH_BASE%|$CI_PATH_BASE|g;s|%S2P_PATH_LOG%|$S2P_PATH_LOG|g;s|%S2P_PATH_RUN%|$S2P_PATH_RUN|g;s|%S2P_OS_USERNAME%|$S2P_OS_USERNAME|g;s|%S2P_OS_GROUPNAME%|$S2P_OS_GROUPNAME|g;s|%HTTP_PORT%|$HTTP_PORT|g;s|%CI_SERVER_NAME%|$CI_SERVER_NAME|g" $CI_PATH_BASE/nanoweb/conf.template/$FILE > $CI_PATH_BASE/nanoweb/conf/$FILE
done

#############################################################################################
# Lighttpd

sed "s|%CI_PATH_BASE%|$CI_PATH_BASE|g;s|%S2P_PATH_LOG%|$S2P_PATH_LOG|g;s|%S2P_PATH_RUN%|$S2P_PATH_RUN|g;s|%S2P_OS_USERNAME%|$S2P_OS_USERNAME|g;s|%S2P_OS_GROUPNAME%|$S2P_OS_GROUPNAME|g;s|%HTTP_PORT%|$HTTP_PORT|g;s|%CI_SERVER_NAME%|$CI_SERVER_NAME|g" $CI_PATH_BASE/lighttpd/conf.template/lighttpd.conf > /etc/lighttpd/lighttpd.conf
sed "s|%CI_PATH_BASE%|$CI_PATH_BASE|g;s|%S2P_PATH_LOG%|$S2P_PATH_LOG|g;s|%S2P_PATH_RUN%|$S2P_PATH_RUN|g;s|%S2P_OS_USERNAME%|$S2P_OS_USERNAME|g;s|%S2P_OS_GROUPNAME%|$S2P_OS_GROUPNAME|g;s|%HTTP_PORT%|$HTTP_PORT|g;s|%CI_SERVER_NAME%|$CI_SERVER_NAME|g" $CI_PATH_BASE/lighttpd/conf.template/php.ini > /etc/php5/cgi/php.ini

ln -s /etc/lighttpd/conf-available/10-fastcgi.conf /etc/lighttpd/conf-enabled/10-fastcgi.conf &> /dev/null
sed "s/^chown [^:]\+:[^ ]\+ /chown $S2P_OS_USERNAME:$S2P_OS_GROUPNAME /" -i /etc/init.d/lighttpd

update-rc.d -f lighttpd remove

#############################################################################################
# Sudoers

grep -v "$CI_PATH_BASE/libexec/set_zoneinfo.sh" /etc/sudoers > /etc/sudoers.tmp
echo -e "%$S2P_OS_GROUPNAME\tALL=(ALL) NOPASSWD:$CI_PATH_BASE/libexec/set_zoneinfo.sh" >> /etc/sudoers.tmp
mv /etc/sudoers.tmp /etc/sudoers
chown root.root /etc/sudoers
chmod 440 /etc/sudoers

grep -v "$CI_PATH_BASE/libexec/reboot.sh" /etc/sudoers > /etc/sudoers.tmp
echo -e "%$S2P_OS_GROUPNAME\tALL=(ALL) NOPASSWD:$CI_PATH_BASE/libexec/reboot.sh" >> /etc/sudoers.tmp
mv /etc/sudoers.tmp /etc/sudoers
chown root.root /etc/sudoers
chmod 440 /etc/sudoers

grep -v "$CI_PATH_BASE/libexec/restart.sh" /etc/sudoers > /etc/sudoers.tmp
echo -e "%$S2P_OS_GROUPNAME\tALL=(ALL) NOPASSWD:$CI_PATH_BASE/libexec/restart.sh" >> /etc/sudoers.tmp
mv /etc/sudoers.tmp /etc/sudoers
chown root.root /etc/sudoers
chmod 440 /etc/sudoers

grep -v "$CI_PATH_BASE/libexec/shutdown.sh" /etc/sudoers > /etc/sudoers.tmp
echo -e "%$S2P_OS_GROUPNAME\tALL=(ALL) NOPASSWD:$CI_PATH_BASE/libexec/shutdown.sh" >> /etc/sudoers.tmp
mv /etc/sudoers.tmp /etc/sudoers
chown root.root /etc/sudoers
chmod 440 /etc/sudoers

#############################################################################################
# Crontab

CRONTAB_LINE="0 *	* * *	$S2P_OS_USERNAME	$CI_PATH_BASE/bin/backup.sh cron"
COUNT=`grep "$CI_PATH_BASE/bin/backup.sh" /etc/crontab -c`
if [ $COUNT -lt "1" ]; then
	echo "$CRONTAB_LINE" >> /etc/crontab
fi

CRONTAB_LINE="0 *	* * *	root	$CI_PATH_BASE/bin/clocksync.sh"
COUNT=`grep "$CI_PATH_BASE/bin/clocksync.sh" /etc/crontab -c`
if [ $COUNT -lt "1" ]; then
	echo "$CRONTAB_LINE" >> /etc/crontab
fi

/etc/init.d/cron restart
