<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/forms.inc.php');
	require_once(CI_PATH_LIBS.'/channels_sip.inc.php');

	CI_AUTH::require_auth('admin', array('reply' => 'html'));

	$hidden_fields=array(
		'id'	=> $_REQUEST['id'],
		'task'	=> 'save'
	);

	$fields=array(
		'base'	=> array(
			'fields'	=> array(
				'desc'				=> array('type' => 'text'),
				'auth_mode'			=> array('type' => 'select', 'options' => array(
																				'auth' 		=> ci_lbl('channels.sip.info.auth_mode.auth'),
																				'trusted' 	=> ci_lbl('channels.sip.info.auth_mode.trusted')
																					),
																'extra'	=> array('onchange' => 'on_auth_change()')
				),
				'link_mode'			=> array('type' => 'select', 'options' => array(
																				'friend'	=> ci_lbl('channels.sip.info.link_mode.friend'),
																				'user'		=> ci_lbl('channels.sip.info.link_mode.user')
																					)
				),
				'username'			=> array('type' => 'text'),
				'password'			=> array('type' => 'password'),
				'authuser'			=> array('type' => 'text'),
				'ip'				=> array('type' => 'text'),
				'port'				=> array('type' => 'int'),
				'dtmf_mode'			=> array('type' => 'select', 'options' => array(
																				'rfc2833' => ci_lbl('channels.sip.info.dtmf_mode.rfc2833'),
																				'rfc2833-strict' => ci_lbl('channels.sip.info.dtmf_mode.rfc2833-strict'),
																				'info' => ci_lbl('channels.sip.info.dtmf_mode.info')
																					)
				),
				'enabled'			=> array('type' => 'yesno')
			)
		),
		'advanced'	=> array(
			'fields'	=> array(
				'dtmf_duration'			=> array('type' => 'int'),
				'packet_size'			=> array('type' => 'int')
			)
		)
	);

	$manager=new CI_CHANNELS_SIP();
	$info=$manager->get_info($_REQUEST['id']);

	/* Default values */
	if (!$_REQUEST['id'])
	{
		$info['dtmf_duration']='300';
		$info['packet_size']='20';
		$info['enabled']='true';
	}

	$form=new CI_FORMS('form');
	$form->set_values($info);
	$form->set_action('actions/channels_sip.php');
	$form->set_fields($fields);
	$form->set_hidden_fields($hidden_fields);
	$form->set_tabs_label_prefix('channels.sip.info.tab-');
	$form->set_fields_label_prefix('channels.sip.info.fld-');

	$form->buttons->add_stock_button('back');
	$form->buttons->add_stock_button('reset');
	if ($_REQUEST['id']) $form->buttons->add_stock_button('delete');
	$form->buttons->add_stock_button('save');
?>
<script type="text/javascript">
	function on_modal_results(id, res)
	{
		if ((id=="delete") && (res==true))
		{
			$('form').task.value="delete";
			$('form').do_submit();
			ci_load_page('channels/sip/index2.php');
		}
	}
	
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'back':	ci_load_page('channels/sip/index2.php'); break;
			case 'reset':	$('form').reset(); break;
			case 'save':	$('form').do_submit(); break;
			case 'delete':	ci_modal_confirm("delete", "<?php echo ci_lbl('channels.sip.info.confirm-delete') ?>", "on_modal_results"); break;
		}
		ci_hide_error_block('form_error');
	}

	function on_form_event(id, task)
	{
	}

	function on_auth_change()
	{
		var val=$('form').auth_mode.value;

		if (window.ie6)
		{
			$('authuser').style.display	= (val != 'trusted') ? 'block' : 'none';
			$('password').style.display	= (val != 'trusted') ? 'block' : 'none';
			$('ip').style.display		= (val == 'trusted') ? 'block' : 'none';
			$('port').style.display		= (val == 'trusted') ? 'block' : 'none';
		}

		$('form').authuser.disabled	= (val == 'trusted');
		$('form').password.disabled	= (val == 'trusted');
		$('form').ip.disabled		= (val != 'trusted');
		$('form').port.disabled		= (val != 'trusted');
	}
</script>

<?php if ($_REQUEST['id']) { ?>
<div class="title"><?php echo ci_lbl("channels.sip.info.title", array('name' => $info['desc'])) ?></div>
<?php } else { ?>
<div class="title"><?php echo ci_lbl("channels.sip.info.title-new") ?></div>
<?php } ?>

<div class="help"><?php echo ci_hlp("channels.sip.info") ?></div>

<?php echo $form->get() ?>

<script type="text/javascript">on_auth_change()</script>

