<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/forms.inc.php');
	require_once(CI_PATH_LIBS.'/settings.inc.php');

	CI_AUTH::require_auth('admin', array('reply' => 'html'));

	$hidden_fields=array('task'	=> 'save');

	$fields=array(
		'config'	=> array(
			'fields'	=> array(
				'config_enabled'		=> array('type' => 'yesno'),
				'config_media'			=> array('type' => 'media', 'modes' => array('file'), 'extra' => array('onchange' => 'on_config_media_change()')),
				'config_frequency'		=> array('type' => 'select', 'options' => array(
					'manual'	=> ci_lbl("settings.backup.frequency.manual"),
					'6h'		=> ci_lbl("settings.backup.frequency.6h"),
					'12h'		=> ci_lbl("settings.backup.frequency.12h"),
					'1d'		=> ci_lbl("settings.backup.frequency.1d"),
					'1w'		=> ci_lbl("settings.backup.frequency.1w"),
					'1m'		=> ci_lbl("settings.backup.frequency.1m")
				)),
				'config_message_subject'	=> array('type' => 'text'),
				'config_message_body'		=> array('type' => 'textarea')
			)
		),
		'callslog'	=> array(
			'fields'	=> array(
				'callslog_enabled'		=> array('type' => 'yesno'),
				'callslog_media'		=> array('type' => 'media', 'modes' => array('file'), 'extra' => array('onchange' => 'on_callslog_media_change()')),
				'callslog_frequency'		=> array('type' => 'select', 'options' => array(
					'manual'	=> ci_lbl("settings.backup.frequency.manual"),
					'6h'		=> ci_lbl("settings.backup.frequency.6h"),
					'12h'		=> ci_lbl("settings.backup.frequency.12h"),
					'1d'		=> ci_lbl("settings.backup.frequency.1d"),
					'1w'		=> ci_lbl("settings.backup.frequency.1w"),
					'1m'		=> ci_lbl("settings.backup.frequency.1m")
				)),
				'callslog_compress'			=> array('type' => 'yesno'),
				'callslog_message_subject'	=> array('type' => 'text'),
				'callslog_message_body'		=> array('type' => 'textarea')
			)
		)
	);

	$media_manager=new CI_SETTINGS_MEDIA();
	$media_items=$media_manager->get_list();

	$manager=new CI_SETTINGS_BACKUP();

	$info=$manager->get_info();

	$form=new CI_FORMS('form');
	$form->set_values($info);
	$form->set_action('actions/settings_backup.php');
	$form->set_fields($fields);
	$form->set_hidden_fields($hidden_fields);
	$form->set_tabs_label_prefix('settings.backup.tab-');
	$form->set_fields_label_prefix('settings.backup.fld-');

	$form->buttons->add_stock_button('createnow');
	$form->buttons->add_stock_button('save');
?>
<script type="text/javascript">
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'save':		$('form').do_submit(); break;
			case 'createnow':
				ci_load_page('settings/backup/sent.php');
				break;
		}
		ci_hide_error_block('form_error');
	}

	function on_form_event(id, task)
	{
	}

	function on_config_media_change()
	{
		if (!$('form').config_media.value)
		{
			$('form').config_frequency.disabled		= true;
			$('form').config_message_subject.disabled	= true;
			$('form').config_message_body.disabled		= true;
			return;
		}

		var val=$('form').config_media.options[$('form').config_media.selectedIndex].title;

		email_disabled	= (val != 'email');
		ftp_disabled	= (val != 'ftp');

		$('form').config_frequency.disabled		= (val == 'disabled');

		$('form').config_message_subject.disabled	= email_disabled;
		$('form').config_message_body.disabled		= email_disabled;
	}

	function on_callslog_media_change()
	{
		if (!$('form').callslog_media.value)
		{
			$('form').callslog_frequency.disabled		= true;
			$('form').callslog_compress.disabled		= true;
			$('form').callslog_message_subject.disabled	= true;
			$('form').callslog_message_body.disabled	= true;
			return;
		}
		
		var val=$('form').callslog_media.options[$('form').callslog_media.selectedIndex].title;

		email_disabled	= (val != 'email');
		ftp_disabled	= (val != 'ftp');

		$('form').callslog_frequency.disabled		= (val == 'disabled');
		$('form').callslog_compress.disabled		= (val == 'disabled');

		$('form').callslog_message_subject.disabled		= email_disabled;
		$('form').callslog_message_body.disabled		= email_disabled;
	}
</script>

<?php if (!sizeof($media_items)) { ?><div class="warn_block"><?php echo ci_lbl("common.nomedia") ?></div><?php } ?>
<div class="title"><?php echo ci_lbl("settings.backup.title") ?></div>
<div class="help"><?php echo ci_hlp("settings.backup") ?></div>

<?php echo $form->get() ?>

<script type="text/javascript">
	on_config_media_change();
	on_callslog_media_change();
</script>
