<?php
	require_once(CI_PATH_LIBS.'/config.inc.php');
	require_once(CI_PATH_LIBS.'/core.inc.php');

	class CI_CHANNELS_ZAP extends CI_CONFIG
	{
		private $channels_manager;
		
		function CI_CHANNELS_ZAP()
		{
			$this->channels_manager=new CI_CORE_CHANNELS_MANAGER();
			$this->channels_manager->open();
		}
		
		function get_config_file()
		{
			return CORE_PATH_BASE.'/config/drivers/zap.xml';
		}

		function set_flag_reload()
		{
			ci_set_core_flag('channels_manager.reload-zap', '1');
		}

		function get_flag_reload()
		{
			return ci_get_core_flag('channels_manager.reload-zap');
		}

		function get_tonezones()
		{
			return array(
				"custom"	=> "Custom tones (advanced users)",
				"us" => "United States / North America",
				"au" => "Australia",
				"fr" => "France",
				"nl" => "Netherlands",
				"uk" => "United Kingdom",
				"fi" => "Finland",
				"es" => "Spain",
				"jp" => "Japan",
				"no" => "Norway",
				"at" => "Austria",
				"nz" => "New Zealand",
				"it" => "Italy",
				"us-old" => "United States Circa 1950 / North America",
				"gr" => "Greece",
				"tw" => "Taiwan",
				"cl" => "Chile",
				"se" => "Sweden",
				"be" => "Belgium",
				"sg" => "Singapore",
				"il" => "Israel",
				"br" => "Brazil",
				"hu" => "Hungary",
				"lt" => "Lithuania",
				"pl" => "Poland",
				"za" => "South Africa",
				"pt" => "Portugal",
				"ee" => "Estonia",
				"mx" => "Mexico",
				"in" => "India",
				"de" => "Germany",
				"ch" => "Switzerland",
				"dk" => "Denmark",
				"cz" => "Czech Republic",
				"cn" => "China",
				"ar" => "Argentina",
				"my" => "Malaysia",
				"th" => "Thailand",
				"bg" => "Bulgaria",
				"ve" => "Venezuela",
				"ph" => "Philippines",
				"ru" => "Russian Federation"
			);
		}

		function get_devices()
		{
			$out=array();

			$count=0;
			$res=$this->channels_manager->ask('zap', 'list_devices');
			foreach ($res['args'] as $k => $v)
			{
				$count++;
				$res2=$this->channels_manager->ask('zap', 'get_device_info', array('n' => $count));
				$res3=$this->channels_manager->ask('zap', 'list_bchannels', array('n' => $count));
				$res2['args']['bchannels']=sizeof(array_keys($res3['args']));

				if (preg_match("/TDM400P/", $res2['args']['name']))			$res2['args']['image']="tdm400p";
				elseif (preg_match("/TDM410P/", $res2['args']['name']))		$res2['args']['image']="tdm410p";
				elseif (preg_match("/TDM800P/", $res2['args']['name'])) 	$res2['args']['image']="tdm800p";
				elseif (preg_match("/TDM2400P/", $res2['args']['name'])) 	$res2['args']['image']="tdm2400p";
				elseif (preg_match("/TE110P/", $res2['args']['name'])) 		$res2['args']['image']="te110p";
				elseif (preg_match("/TE120P/", $res2['args']['name'])) 		$res2['args']['image']="te120p";
				elseif (preg_match("/TE122P/", $res2['args']['name'])) 		$res2['args']['image']="te122p";
				elseif (preg_match("/TE205P/", $res2['args']['name'])) 		$res2['args']['image']="te205p";
				elseif (preg_match("/TE210P/", $res2['args']['name'])) 		$res2['args']['image']="te210p";
				elseif (preg_match("/TE405P/", $res2['args']['name'])) 		$res2['args']['image']="te405p";
				elseif (preg_match("/TE406P/", $res2['args']['name'])) 		$res2['args']['image']="te406p";
				elseif (preg_match("/TE407P/", $res2['args']['name'])) 		$res2['args']['image']="te407p";
				elseif (preg_match("/TE411P/", $res2['args']['name'])) 		$res2['args']['image']="te411p";
				elseif (preg_match("/TE412P/", $res2['args']['name'])) 		$res2['args']['image']="te412p";
				elseif (preg_match("/WRTDM/", $res2['args']['code'])) 		$res2['args']['image']="tdm_sangoma";
				elseif (preg_match("/WP/", $res2['args']['code']) && $res2['args']['bchannels']>30) 			$res2['args']['image']="a102";
				elseif (preg_match("/WP/", $res2['args']['code']) && $res2['args']['bchannels']<=30) 			$res2['args']['image']="a101";
				elseif (preg_match("/TE\d+/", $res2['args']['name'])) 		$res2['args']['image']="te_generic";
				elseif (preg_match("/TDM\d+/", $res2['args']['name'])) 		$res2['args']['image']="tdm_generic";
				else														$res2['args']['image']="zap_generic";

				array_push($out, $res2['args']);
			}
		
			return $out;	
		}

		function get_map($info)
		{
			return array(
				'id'				=> $info['id'],
				'media'				=> $info['media'],
				'composing_timeout'	=> intval($info['composing-timeout']),
				'crc4'				=> $info['crc4'],
				'tx_gain'			=> number_format(floatval($info['tx-gain']), 1),
				'rx_gain'			=> number_format(floatval($info['rx-gain']), 1),
				'echo_cancel'		=> $info['echo-cancel'],
				'reverse_polarity'	=> $info['reverse-polarity'],
				'nodetype'			=> $info['nodetype'],
				'swtype'			=> $info['swtype'],
				'layer'				=> $info['layer'],
				'overlap_dial'		=> $info['overlap-dial'],
				'timing'			=> intval($info['timing']),
				'lbo'				=> $info['lbo'],
				'framing'			=> $info['framing'],
				'coding'			=> $info['coding'],
				'yellow'			=> $info['yellow'],
				'relax_dtmf'		=> $info['relax-dtmf'],
				'busy_detect'		=> intval($info['busy-detect'])
			);
		}

		function get_rmap($info)
		{
			return array(
				'id'				=> $info['id'],
				'media'				=> $info['media'],
				'composing-timeout'	=> intval($info['composing_timeout']),
				'crc4'				=> $info['crc4'],
				'tx-gain'			=> number_format(floatval($info['tx_gain']), 1),
				'rx-gain'			=> number_format(floatval($info['rx_gain']), 1),
				'echo-cancel'		=> $info['echo_cancel'],
				'reverse-polarity'	=> $info['reverse_polarity'],
				'nodetype'			=> $info['nodetype'],
				'swtype'			=> $info['swtype'],
				'layer'				=> $info['layer'],
				'overlap-dial'		=> $info['overlap_dial'],
				'timing'			=> intval($info['timing']),
				'lbo'				=> $info['lbo'],
				'framing'			=> $info['framing'],
				'coding'			=> $info['coding'],
				'yellow'			=> $info['yellow'],
				'relax-dtmf'		=> $info['relax_dtmf'],
				'busy-detect'		=> intval($info['busy_detect'])
			);
		}

		function get_global_map($info)
		{
			return array(
				'tonezone'			=> $info['tonezone'],
				'dialtone'			=> $info['tonezone-custom']['dialtone'],
				'busy'				=> $info['tonezone-custom']['busy'],
				'ringtone'			=> $info['tonezone-custom']['ringtone'],
				'congestion'		=> $info['tonezone-custom']['congestion'],
				'callwait'			=> $info['tonezone-custom']['callwait'],
				'dialrecall'		=> $info['tonezone-custom']['dialrecall'],
				'recordtone'		=> $info['tonezone-custom']['recordtone'],
				'info'				=> $info['tonezone-custom']['info'],
				'stutter'			=> $info['tonezone-custom']['stutter'],
				'ringcadence'		=> $info['tonezone-custom']['ringcadence'],
				'dtmf_high_level'	=> intval($info['tonezone-custom']['dtmf-high-level']),
				'dtmf_low_level'	=> intval($info['tonezone-custom']['dtmf-low-level'])
			);
		}

		function get_global_rmap($info)
		{
			return array(
				'tonezone' 			=> $info['tonezone'],
				'tonezone-custom'	=> array(
					'dialtone'			=> $info['dialtone'],
					'busy'				=> $info['busy'],
					'ringtone'			=> $info['ringtone'],
					'congestion'		=> $info['congestion'],
					'callwait'			=> $info['callwait'],
					'dialrecall'		=> $info['dialrecall'],
					'recordtone'		=> $info['recordtone'],
					'info'				=> $info['info'],
					'stutter'			=> $info['stutter'],
					'ringcadence'		=> $info['ringcadence'],
					'dtmf-high-level'	=> intval($info['dtmf_high_level']),
					'dtmf-low-level'	=> intval($info['dtmf_low_level'])
				)
			);
		}

		function get_global_info()
		{
			$config =& ci_get_unserialized_xml($this->get_config_file());
			return $this->get_global_map($config['zap']);
		}

		function task_save_global($info)
		{
			$config 		=& ci_get_unserialized_xml($this->get_config_file());
			$config['zap']	=& $this->get_global_rmap($info);

			$this->set_flag_reload();

			ci_save_xml($this->get_config_file(), $config, 'config');
			return ci_response_ok();
		}

		function save_raw_config($array)
		{
			$config =& ci_get_unserialized_xml($this->get_config_file());
			if (!sizeof($array))
				$array2=array();
			else
				$array2['item'] =& $array;

			$config['devices']=$array2;

			$this->set_flag_reload();

			ci_save_xml($this->get_config_file(), $config);
			return ci_response_ok();
		}

		function get_raw_list()
		{
			$config =& ci_get_unserialized_xml($this->get_config_file());
			return ci_normalize_xml_array($config['devices']['item']);
		}

		function get_info($id)
		{
			$info =& parent::get_info($id);
			return $info;
		}

		function task_save($info)
		{
			if (!$info['media'])
			{
				$info2=$this->get_info($info['id']);
				$info['media']=$info2['media'];
			}
			
			/* Compose fields */
			$fields=$this->get_rmap($info);

			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;

			$this->save_raw_config($list);
			return ci_response_ok();
		}
	}
?>