<?php
	require_once(CI_PATH_LIBS.'/config.inc.php');
	
	class CI_ROUTES_IN extends CI_CONFIG
	{
		function get_config_file()
		{
			return IGX_PATH_BASE.'/config/routes/routes-in.xml';
		}

		function get_rmap($info)
		{
			return array(
				'id'		=> $info['id'],
				'desc'		=> $info['desc'],
				'to-skype'	=> array(
					'item'	=> split(',', $info['to_skype'])
				),
				'use-channel'	=> array(
					'item'	=> split(',', $info['use_channel'])
				),
				'algorithm'	=> $info['algorithm'],
				'userdata'	=> array(
					'castiron-fallback'	=> $info['fallback']
				)
			);
		}

		function get_map($info)
		{
			$info['to-skype']['item']=@ci_normalize_xml_array($info['to-skype']['item']);
			$info['use-channel']['item']=@ci_normalize_xml_array($info['use-channel']['item']);
			
			return array(
				'id'					=> $info['id'],
				'desc'					=> $info['desc'],
				'to_skype'				=> join(',', $info['to-skype']['item']),
				'use_channel'			=> join(',', $info['use-channel']['item']),
				'algorithm'				=> $info['algorithm'],
				'fallback'				=> $info['userdata']['castiron-fallback']
			);
		}
		
		function task_save($info)
		{
			if (!$info['id']) $info['id']=md5(uniqid(''));
			
			$fields=$this->get_rmap($info);
			
			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;
			
			$this->save_raw_config($list);
			
			return ci_response_ok();
		}
	}

	class CI_ROUTES_OUT extends CI_CONFIG
	{
		function get_config_file()
		{
			return IGX_PATH_BASE.'/config/routes/routes-out.xml';
		}

		function get_rmap($info)
		{
			return array(
				'id'		=> $info['id'],
				'desc'		=> $info['desc'],
				'use-skype'	=> array(
					'item'	=> split(',', $info['use_skype'])
				),
				'from-channel'	=> array(
					'item'	=> split(',', $info['from_channel'])
				),
				'algorithm'	=> $info['algorithm']
			);
		}

		function get_map($info)
		{
			$info['use-skype']['item']=@ci_normalize_xml_array($info['use-skype']['item']);
			$info['from-channel']['item']=@ci_normalize_xml_array($info['from-channel']['item']);
			
			return array(
				'id'					=> $info['id'],
				'desc'					=> $info['desc'],
				'use_skype'				=> join(',', $info['use-skype']['item']),
				'from_channel'			=> join(',', $info['from-channel']['item']),
				'algorithm'				=> $info['algorithm']
			);
		}
		
		function task_save($info)
		{
			if (!$info['id']) $info['id']=md5(uniqid(''));
			
			$fields=$this->get_rmap($info);
			
			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;
			
			$this->save_raw_config($list);
			
			return ci_response_ok();
		}
	}
?>