<?php
	class CI_SETTINGS_LOCALE extends CI_SETTINGS
	{
		function get_info()
		{
			global $CI_CORE_CONFIG;

			$info=array();

			/* Reading default prefix from public map */
			$f=file_get_contents(IGX_PATH_BASE.'/config/maps/public.xml');
			preg_match('/<default\-prefix>([^<]+)<\/default\-prefix>/', $f, $matches);
			$info['default_prefix']=$matches[1];

			/* Reading time zone */
 			$info['time_zone']=ci_get_os_timezone();

 			/* Reading default language */
 			$info['default_language']=$CI_CORE_CONFIG['language'];

			return $info;
		}

		function task_save($info)
		{
			global $CI_CONFIG_SYSTEM;

			/* Set default prefix */
			$f=file_get_contents(IGX_PATH_BASE.'/config/maps/public.xml');
			$f=preg_replace('/<default\-prefix>[^<]*<\/default\-prefix>/', "<default-prefix>".htmlspecialchars($info['default_prefix'])."</default-prefix>", $f);
			$fp=@fopen(IGX_PATH_BASE.'/config/maps/public.xml', 'w');
			if (!$fp)
			{
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'default_prefix',
						'desc'		=> ci_lbl('libsettings.error.cannot-write', array('file' => IGX_PATH_BASE.'/config/maps/public.xml'))
					)
				);
			}
			fputs($fp, $f);
			fclose($fp);

			/* Set language */
			$f=file_get_contents(CORE_PATH_BASE.'/config/system.xml');
			$f=preg_replace('/<language>[^<]+<\/language>/', "<language>".htmlspecialchars($info['default_language'])."</language>", $f);
			$fp=@fopen(CORE_PATH_BASE.'/config/system.xml', 'w');
			if (!$fp)
			{
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'default_prefix',
						'desc'		=> ci_lbl('libsettings.error.cannot-write', array('file' => CORE_PATH_BASE.'/config/system.xml'))
					)
				);
			}
			fputs($fp, $f);
			fclose($fp);

			/* Set local time */
			$res=system('sudo '.CI_PATH_LIBEXEC.'/set_zoneinfo.sh '.escapeshellarg($info['time_zone']));
			if ($res)
			{
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'time_zone',
						'desc'		=> ci_lbl('libsettings_locale.error.timezone')
					)
				);
			}

			
			return ci_response_ok();
		}
	}
?>