#!/bin/bash

cd `dirname $0`
MYDIR=`pwd`
MYSCRIPT=`basename $0`
cd ../..
S2P_PATH_BASE=`pwd`
cd $MYDIR

S2P_OS_USERNAME=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^os.username | cut -d= -f2`
if [[ `whoami` != "$S2P_OS_USERNAME" ]]; then
	exec sudo -u $S2P_OS_USERNAME ./$MYSCRIPT $@
fi

##########################################################################################
# Paths definition

TMP_PATH_BASE=$S2P_PATH_BASE/tmp
BACKUP_PATH_BASE=$S2P_PATH_BASE/backup
CORE_PATH_BASE=$S2P_PATH_BASE/core
APPS_PATH_BASE=$S2P_PATH_BASE/apps

TS=`date +%Y%m%d%H%M%S`
BACKUP_PATH=$BACKUP_PATH_BASE/backup-$TS.tmp

##########################################################################################
# Structure

mkdir -p $BACKUP_PATH &> /dev/null

##########################################################################################
# Core config

mkdir -p $BACKUP_PATH/core/config
cp -Rfp $CORE_PATH_BASE/config/* $BACKUP_PATH/core/config

##########################################################################################
# List of applications

APPS_LIST=`ls -1 $APPS_PATH_BASE`

for APP in $APPS_LIST; do
	if [ -d $APPS_PATH_BASE/$APP ]; then

		CONF=$APPS_PATH_BASE/$APP/config
		if [ -d $CONF ]; then
			mkdir -p $BACKUP_PATH/apps/$APP/config &> /dev/null
			cp -Rfp $APPS_PATH_BASE/$APP/config/* $BACKUP_PATH/apps/$APP/config
		fi

		LOCAL=$APPS_PATH_BASE/$APP/local
		if [ -d $LOCAL ]; then
			mkdir -p $BACKUP_PATH/apps/$APP/local &> /dev/null
			cp -Rfp $APPS_PATH_BASE/$APP/local/* $BACKUP_PATH/apps/$APP/local
		fi
	fi
done

##########################################################################################
# Compressing archive

cd $BACKUP_PATH

(tar -c * > $BACKUP_PATH_BASE/backup-$TS.tar) &> /dev/null
(gzip $BACKUP_PATH_BASE/backup-$TS.tar) &> /dev/null

rm -Rf $BACKUP_PATH &> /dev/null

echo $BACKUP_PATH_BASE/backup-$TS.tar.gz
